
require 'sketchup.rb'

class CSDictionary

  def validate
  
    Sketchup.send_action "showRubyPanel:"
	Sketchup.active_model.start_operation "Validate Dictionary", true
	
    list = Sketchup.active_model.selection
	if list.empty?
	  list = Sketchup.active_model.entities
	end
	
	puts " "
	puts "--- begining validation and cleanse ---"
	
	validateRecursive(list)
    
    Sketchup.active_model.commit_operation
	
	puts " "
	puts "--- done ---"
  end
  
  def validateRecursive(list)	 
	map = Hash.new()
    for c in list
      if c.typename == "ComponentInstance" 
		dict=c.definition.attribute_dictionary("dynamic_attributes")
		if dict == nil
		  puts "skipping: object is not a dynamic component"
		  next
		end
		dict.each { | key, value |
			map[key] = value if key[0,1] != "_" && key[0,7] != "onclick"
		}
		dict = c.attribute_dictionary("dynamic_attributes")
		if dict == nil
		  puts "Component Instance is missing its dynamic_attributes dictionary"
		  next
		end
		dict.each { | key, value |
			map.delete(key) if key[0,1] != "_"
		}
		if map.length == 0
		  puts c.definition.name + ": clean"
		else
		  puts " "
		  puts c.definition.name + ": errors"
		  puts "-----------------------"
		  map.each {|key, value| 
			c.set_attribute("dynamic_attributes", key, value)
			puts "fixed: " + key.to_s + '=' + value.to_s
		  }
		  puts "-----------------------"
		  puts " "
		end		
	    validateRecursive(c.definition.entities)
	  end
	end
  end  

  def listAll
  
    Sketchup.send_action "showRubyPanel:"
	Sketchup.active_model.start_operation "Validate Dictionary", true
	map = Hash.new()
	
    list = Sketchup.active_model.selection
	if list.empty?
	  list = Sketchup.active_model.entities
	end
	 
    for c in list
      if c.typename == "ComponentInstance" 
		dict=c.definition.attribute_dictionary("dynamic_attributes")
		if dict == nil
		  puts c.typename + " is not a dynamic component"
		  return
		end
		puts " "
		puts "Component Definition"
		puts "================="
		puts " "
		dict.each { | key, value |
			puts key.to_s + '=' + value.to_s			
			map[key] = value if key[0,1] != "_" && key[0,7] != "onclick"
		}
		dict = c.attribute_dictionary("dynamic_attributes")
		if dict == nil
		  puts "Component Instance is missing its dynamic_attributes dictionary"
		  return
		end
		puts " "
		puts "Component Instance"
		puts "================="
		puts " "
		dict.each { | key, value |
			puts key.to_s + '=' + value.to_s
			map.delete(key) if key[0,1] != "_"
		}
		if map.length == 0
		  puts " "
		  puts "=========================="
		  puts "Dynamic Component is clean"
		  puts "=========================="
		else
		  puts " "
		  puts "Missing Instance attributes"
		  puts "==========================="
		  puts " "
		  map.each {|key, value| 
			puts key.to_s + '=' + value.to_s
		  }
		end		
		
		break
	  end
	end

    # All done, so commit the operation.
    Sketchup.active_model.commit_operation

  end  

end


if( not $csValidateDC_loaded )

  csDictionary = CSDictionary.new

  # Set up some UI hooks.
  plugins_menu = UI.menu "Plugins"
  plugins_menu.add_item("Create missing DC KeyValues") {
    csDictionary.validate
  }

  UI.add_context_menu_handler do |context_menu| 
    context_menu.add_separator
    context_menu.add_item("List DC KeyValues") do
      csDictionary.listAll
    end
    context_menu.add_item("Create missing DC KeyValues") do
      csDictionary.validate
    end
  end

  $csValidateDC_loaded = true

end
